//! Print splash shit

use super::*;

pub fn print_stats()
{
    use recolored::Colorize;
    lazy_static! {
	static ref AUTHORS: &'static str = Box::leak(env!("CARGO_PKG_AUTHORS").replace( ":", ", ").into_boxed_str());

    };
    
    #[cfg(debug_assertions)]
    lazy_static!{
	static ref BUILD_IDENT: recolored::ColoredString = "debug".bright_blue();
    }
    #[cfg(not(debug_assertions))]
    lazy_static!{
	static ref BUILD_IDENT: recolored::ColoredString = "release".bright_red();
    }

    #[allow(unused_imports)]
    use std::ops::Deref;
    status!("This is the lolicron daemon version {} by {} ({} build)", env!("CARGO_PKG_VERSION"), &AUTHORS[..], BUILD_IDENT.deref());
    status!("---");
    status!("Compiled with ({} ({}), {} ({})):", "on".bright_red(), "default".red(), "off".bright_blue(), "default".blue());

    #[cfg(nightly)] status!(" +nightly".bright_red());
    #[cfg(debug_assertions)] status!(" +debug_assertions".red());
    
    status!("features:");

    #[cfg(feature="threaded")] status!(" +threaded".red());
    #[cfg(not(feature="threaded"))] status!(" -threaded".bright_blue());

    #[cfg(feature="watcher")] status!(" +watcher".red());
    #[cfg(not(feature="watcher"))] status!(" -watcher".bright_blue());
    
    #[cfg(feature="debug_logger")] status!(" +debug_logger".red());
    #[cfg(not(feature="debug_logger"))] status!(" -debug_logger".bright_blue());
    
    #[cfg(feature="watcher_unlimited")] status!(" +watcher_unlimited".bright_red());
    #[cfg(not(feature="watcher_unlimited"))] status!(" -watcher_unlimited".blue());
    
    #[cfg(feature="watcher_timeout")] status!(" +watcher_timeout".red());
    #[cfg(not(feature="watcher_timeout"))] status!(" -watcher_timeout".bright_blue());
    
    status!("");

    config::build::stat();
    
    status!("GPl'd with <3");
    status!("Please enjoy");
    
    status!("---");
}
